#pragma once

#include "CoreMinimal.h"
#include "KillerDependentObjectInterface.h"
#include "GameFramework/Actor.h"
#include "Templates/SubclassOf.h"
#include "DBDTunableRowHandle.h"
#include "ZombiesManagement.generated.h"

class UAuthoritativeActorPoolComponent;
class UZombiesPatrolAreaManager;
class AZombieCharacter;
class ADBDPlayerState;
class AZombieEscapeDoorPointsActor;

UCLASS(Blueprintable)
class AZombiesManagement : public AActor, public IKillerDependentObjectInterface
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced, meta=(AllowPrivateAccess=true))
	UAuthoritativeActorPoolComponent* _zombiePool;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UZombiesPatrolAreaManager> _zombiesPatrolAreaManagerClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced, meta=(AllowPrivateAccess=true))
	UZombiesPatrolAreaManager* _zombiesPatrolAreaManager;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TArray<AZombieCharacter*> _spawnedZombiesArray;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	ADBDPlayerState* _owningPlayerState;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _firstZombieSpawnTime;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _numberOfZombieToSpawnAtStart;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TArray<AZombieEscapeDoorPointsActor*> _zombieEscapeDoorPoints;

private:
	UFUNCTION(BlueprintCallable)
	void Authority_OnIntroComplete();

public:
	AZombiesManagement();
};

FORCEINLINE uint32 GetTypeHash(const AZombiesManagement) { return 0; }
